#KQML_HOME = ../../..

VPATH = $(KQML_HOME)/src/lib/kqmlparse

KQML_LIB = ${KQML_ARCH}/lib

INCLUDES  = -I. -I${KQML_HOME}/include -I$(KQML_ARCH)/include
LIBDIRS = -L${KQML_LIB}

CC = /usr/local/bin/gcc 

#CFLAGS = -O -Wall ${INCLUDES} # Final version
CFLAGS = -g -DDEBUG -Wall ${INCLUDES}
LDFLAGS = ${LIBDIRS}

STDLIBS = -lm -lc
LOADLIBES = -lkqml ${STDLIBS}

all : kqml_parser.o kqml_scanner.o

kqml_parser.o: kqml_parser.c
	$(CC) $(CFLAGS) -c kqml_parser.c

kqml_scanner.o: kqml_scanner.c
	$(CC) $(CFLAGS) -c $(VPATH)/kqml_scanner.c

kqml_parser.c: kqml.y
	yacc -vd $(VPATH)/kqml.y
	mv y.tab.c kqml_parser.c
	mv y.tab.h ${KQML_ARCH}/include/kqml/kqml.tab.h


test: test_parse

test_parse : test_parse.c kqml_parser.o kqml_scanner.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o test_parse $(VPATH)/test_parse.c \
		kqml_parser.o kqml_scanner.o $(LOADLIBES)


clean :
	rm -f y.output y.tab.c y.tab.h
	rm -f kqml_parser.c ${KQML_ARCH}/include/kqml/kqml.tab.h 
	rm -f kqml_parser.o kqml_scanner.o test_parse test_parse.o
