#if ! defined (__KQMLLIB_H__)

#define __KQMLLIB_H__

#define KQML_VALIDATOR_FLAG	"KQML_USE_VALIDATOR"
#define KQML_ROUTER_ENV			"KQML_ROUTER"
#define KQML_VALIDATOR_ENV		"KQML_VALIDATOR"
#define KQML_ROUTER_NAME		"router"
#define KQML_LOGGER_NAME		"KQML-LoGGeR"
#define KQML_VALIDATOR_NAME	"validator"

#define KQMLPORT_OFFSET		500

#define KQML_HANDSHAKE		"kqml-hello"

#define PARSE_ERROR			(kqml_message *)(-1)

#define KMSG_ID_KEYWORD		":kqml-msg-id"
#define KMSG_READ_TIME		1
#define KMSG_WRITE_TIME		0

#ifdef __cplusplus
extern "C" 
{
#endif

extern int _kqml_im_the_router, _kqml_im_an_ans, _kqml_root_ans;
extern ans_handler _kqml_ans_lookup;

extern int _kqml_put_performative_nd (kqml_message *msg, char *performative);
extern int _kqml_put_field_nd (char *field_name, kqml_message *msg,
	char *value, int value_len, kqml_expression_type value_type);

extern int _kqml_get_subscriber_list (char *content, int content_len, 
	char ***subscirber, char ***subscriber_id);

extern int _kqml_init_xdr (FILE *receive_ptr, FILE *send_ptr);
extern kqml_message *_kqml_fetch_xdr_msg ();
extern int _kqml_send_xdr_msg (kqml_message *kmsg);
extern int _kqml_msgs_in_queue (void);
extern int _kqml_wait_for_msg (int timeout);

extern int _kqml_await (int fd, int seconds);
extern int _kqml_tcp_to_service (int port, char *hostname);

extern handler _kqml_find_handler (char *name);

extern void _kqml_handler (kqml_message *msg);

extern kqml_expression_type _kqml_check_type (char *str, int len,
	char **ret_str, int *ret_len);

extern int _kqml_check_word (char *string, int len);

extern void kqml_print_kmsg_list (FILE *stream, KQML_KMSG_LIST *kmsg_list);
extern int _kqml_pending_bytes (int fd, FILE *fp);

extern char *_kqml_get_reply_with_field (kqml_message *message);

#ifdef __cplusplus
}
#endif

#endif /* __KQMLLIB_H__ */
