#include <kqml/kqmlconf.h>

#include	<stdio.h>
#include <errno.h>			/* errno */
#include <unistd.h>        /* select */
#include	<sys/time.h>		/* select */
#include	<sys/types.h>		/* select */

#ifdef __KQML_MACH_SVR4__ 
#	ifdef __KQML_MACH_SGI__
#		include <bstring.h>			/* Used by FD_SET */
#	else
#		include <memory.h>			/* Used by FD_SET */
#	endif
#include <ulimit.h>
#endif

#ifdef __KQML_MACH_SUN__
extern char *sys_errlist[];
#endif

#include <kqml.h>
#include <kqml/kqmllib.h>

/*
 * await - perform a timeout select on a single fd
 * Return: 1 if more data available
 *	   0 if none
*/
int
_kqml_await (int fd, int seconds)
{
	int i;
	fd_set fdset;
	int dtablesize;
	struct timeval timeout;
  
#	if defined(__KQML_MACH_SVR4__)
		dtablesize = ulimit (UL_GDESLIM, 0);
#	else
		dtablesize = ulimit (4, 0);
#	endif

	timeout.tv_sec = seconds;	       /* initialize timeout */
	timeout.tv_usec = 0;
  
	FD_ZERO (&fdset);
	FD_SET (fd, &fdset);
  
	do
	{
		i = select (dtablesize, &fdset, NULL, NULL, &timeout);
	}
	while ((i < 0) && (errno == EINTR));

	if (i <= -1)
	{
		_kqml_dbg_msg (KQML_DBG_ALWAYS) 
			("_kqml_await: select %s.", sys_errlist[errno]);
	}

	return i;
}
